image: maven:3.6.1-jdk-11

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN"  

stages:
  - maven-deploy
  - push-docker
  - deploy-kubernetes
  - integration-test

cache:
    key: "$CI_COMMIT_REF_NAME"
    paths:
        - .m2/repository

before_script:
    - export MAVEN_USER_HOME=`pwd`/.maven
        
mvn-deploy:
  stage: maven-deploy
  only:
    refs:
      - develop
      - master
      - production
      - tags
      - /^feature.*$/
    variables:
      - $FEATURE_NAME == null
  script:
    - 'mvn clean package -U -s ci_settings.xml'
    - mkdir -p target/dependency && (cd target/dependency; jar -xf ../*.jar)
  artifacts:
    paths:
        - target/classes/
        - target/generated-sources/
        - target/dependency/
    expire_in: 1 day

       
build-push-image:
  stage: push-docker
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
    